Index: trunk/source/visualization/HepRep/src/G4HepRepSceneHandler.cc
===================================================================
--- trunk/source/visualization/HepRep/src/G4HepRepSceneHandler.cc	(revision 1227)
+++ trunk/source/visualization/HepRep/src/G4HepRepSceneHandler.cc	(revision 1228)
@@ -24,5 +24,5 @@
 // ********************************************************************
 //
-// $Id: G4HepRepSceneHandler.cc,v 1.101 2007/11/16 20:29:04 perl Exp $
+// $Id: G4HepRepSceneHandler.cc,v 1.102 2009/11/23 05:42:28 perl Exp $
 // GEANT4 tag $Name:  $
 //
@@ -45,4 +45,5 @@
 //HepRep
 #include "HEPREP/HepRep.h"
+#include "G4HepRepMessenger.hh"
 
 //G4
@@ -90,7 +91,6 @@
 //#define PDEBUG 1
 
-G4HepRepSceneHandler::G4HepRepSceneHandler (G4VGraphicsSystem& system, G4HepRepMessenger& heprepMessenger, const G4String& name)
+G4HepRepSceneHandler::G4HepRepSceneHandler (G4VGraphicsSystem& system, const G4String& name)
         : G4VSceneHandler (system, sceneIdCount++, name),
-          messenger             (heprepMessenger),
           geometryLayer         ("Geometry"),
           eventLayer            ("Event"),
@@ -247,5 +247,8 @@
             writeMultipleFiles = false;
             int startDigit = -1; int endDigit = -1;
-            string suffix = messenger.getEventNumberSuffix();
+
+			G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
+
+            string suffix = messenger->getEventNumberSuffix();
             if (suffix != "") {
                 // look for 0000 pattern in suffix
@@ -331,4 +334,6 @@
         }
     } else {
+		
+		G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
 
         // add geometry to the heprep if there is an event (separate geometries are written
@@ -338,5 +343,6 @@
         
             // couple geometry
-            if (messenger.appendGeometry()) {
+
+            if ( messenger->appendGeometry()) {
                 // couple geometry to event if geometry was written
                 if ((_geometryInstanceTree != NULL)) {
@@ -374,5 +380,5 @@
 
         // write out separate geometry
-        if (!messenger.appendGeometry() && (_heprepGeometry != NULL)) {
+        if (! messenger->appendGeometry() && (_heprepGeometry != NULL)) {
             if (writeMultipleFiles) {
                 char fileName[128];
@@ -493,6 +499,8 @@
 
     if (dontWrite()) return;
-
-    if (!messenger.useSolids()) {
+	
+	G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
+
+    if (! messenger->useSolids()) {
         G4VSceneHandler::AddSolid(box);
         return;
@@ -547,6 +555,8 @@
 
     if (dontWrite()) return;
-
-    if (!messenger.useSolids() || (cons.GetDeltaPhiAngle() < twopi)) {
+	
+	G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
+
+    if (! messenger->useSolids() || (cons.GetDeltaPhiAngle() < twopi)) {
         G4VSceneHandler::AddSolid(cons);
         return;
@@ -609,6 +619,8 @@
 
     if (dontWrite()) return;
-
-    if (!messenger.useSolids() || (tubs.GetDeltaPhiAngle() < twopi)) {
+	
+	G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
+
+    if (! messenger->useSolids() || (tubs.GetDeltaPhiAngle() < twopi)) {
         G4VSceneHandler::AddSolid(tubs);
         return;
@@ -666,6 +678,8 @@
 #endif
     if (dontWrite()) return;
-
-    if (!messenger.useSolids()) {
+	
+	G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
+
+    if (! messenger->useSolids()) {
         G4VSceneHandler::AddSolid(trd);
         return;
@@ -994,6 +1008,7 @@
 
 
-G4bool G4HepRepSceneHandler::dontWrite() {
-    return !(messenger.writeInvisibles() || (fpVisAttribs ? (bool)fpVisAttribs->IsVisible() : true));
+G4bool G4HepRepSceneHandler::dontWrite() {	
+	G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
+    return !( messenger->writeInvisibles() || (fpVisAttribs ? (bool)fpVisAttribs->IsVisible() : true));
 }
 
@@ -1367,10 +1382,12 @@
     type->addAttDef(  "PointUnit", "Length", "Physics", "");
     type->addAttValue("PointUnit", G4String("m"));
+	
+	G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
 
     type->addAttDef(  "UseSolids", "Use HepRep Solids rather than Geant4 Primitives", "Draw", "");
-    type->addAttValue("UseSolids", messenger.useSolids());
+    type->addAttValue("UseSolids", messenger->useSolids());
 
     type->addAttDef(  "WriteInvisibles", "Write Invisible Objects", "Draw", "");
-    type->addAttValue("WriteInvisibles", messenger.writeInvisibles());
+    type->addAttValue("WriteInvisibles", messenger->writeInvisibles());
 }           
 
@@ -1409,5 +1426,7 @@
         // Create the Geometry InstanceTree.
         _geometryInstanceTree = factory->createHepRepInstanceTree("G4GeometryData", "1.0", getGeometryTypeTree());
-        if (messenger.appendGeometry()) {
+		
+		G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
+        if ( messenger->appendGeometry()) {
             getHepRep()->addInstanceTree(_geometryInstanceTree);
         } else {
@@ -1476,5 +1495,7 @@
         HepRepTreeID* geometryTreeID = factory->createHepRepTreeID("G4GeometryTypes", "1.0");
         _geometryTypeTree = factory->createHepRepTypeTree(geometryTreeID);
-        if (messenger.appendGeometry()) {
+		
+		G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
+        if ( messenger->appendGeometry()) {
             getHepRep()->addTypeTree(_geometryTypeTree);
         } else {
Index: trunk/source/visualization/HepRep/src/G4HepRepViewer.cc
===================================================================
--- trunk/source/visualization/HepRep/src/G4HepRepViewer.cc	(revision 1227)
+++ trunk/source/visualization/HepRep/src/G4HepRepViewer.cc	(revision 1228)
@@ -24,5 +24,5 @@
 // ********************************************************************
 //
-// $Id: G4HepRepViewer.cc,v 1.26 2006/06/29 21:17:34 gunter Exp $
+// $Id: G4HepRepViewer.cc,v 1.27 2009/11/23 05:42:28 perl Exp $
 // GEANT4 tag $Name:  $
 //
@@ -40,4 +40,5 @@
 #include "G4Scene.hh"
 #include "G4HepRep.hh"
+#include "G4HepRepMessenger.hh"
 #include "G4HepRepSceneHandler.hh"
 //This
@@ -47,8 +48,7 @@
 using namespace std;
 
-G4HepRepViewer::G4HepRepViewer (G4VSceneHandler& sceneHandler, G4HepRepMessenger& heprepMessenger, const G4String& name)
+G4HepRepViewer::G4HepRepViewer (G4VSceneHandler& sceneHandler, const G4String& name)
         : G4VViewer (sceneHandler, sceneHandler.IncrementViewCount(), name),
-        geometryIncluded(false),
-        messenger(heprepMessenger) {
+        geometryIncluded(false) {
 
 #ifdef SDEBUG
@@ -111,5 +111,7 @@
     if (sceneHandler->closeHepRep()) {
         sceneHandler->openHepRep();
-        if (messenger.appendGeometry()) geometryIncluded = false;
+		
+		G4HepRepMessenger* messenger = G4HepRepMessenger::GetInstance();
+        if (messenger->appendGeometry()) geometryIncluded = false;
     }
 }
Index: trunk/source/visualization/History
===================================================================
--- trunk/source/visualization/History	(revision 1227)
+++ trunk/source/visualization/History	(revision 1228)
@@ -1,3 +1,3 @@
-$Id: History,v 1.456 2009/11/17 14:37:06 lgarnier Exp $
+$Id: History,v 1.460 2009/11/23 05:56:37 perl Exp $
 -------------------------------------------------------------------
 
@@ -25,10 +25,41 @@
 ---------------------------------------
 
+22nd November 2009  Joseph Perl (vis-V09-02-12)
+- vis-HepRep-V09-02-03
+  o Changed messenger to a singleton.
+  o Added messenger commands to HepRepFile.
+  o Render G4Tubs as polygons if G4Tubs is not at a standard angle.
+
+22nd November 2009  John Allison
+- visman-V09-02-08: /vis/scene/add/trajectories rich:
+  o Added G4RichTrajectoryPoint().GetAttDefs() to informational.
+
+18th November 2009  Gabriele Cosmo
+- visexternal-V09-02-06:
+  o Added GLOBLIBS dependencies.
+  o Re-instated fix to gl2ps.cc (always #define GL2PS_HAVE_ZLIB).
+
+17th November 2009  John Allison  (vis-V09-02-11)
+- visman-V09-02-07:
+  o Many small bug fixes.
+  o Enhanced functionality for gMocren driver:
+    . Introduced the concept of end-of-run model.
+- opengl-V09-02-10: Fixes build problem with gl2ps on Windows.
+- openinventor-V09-02-03: Fixes build problem with gl2ps on Windows.
+- Tagged for vis tag.
+- visexternal-V09-02-05:
+  o gl2ps: Added dependency on zlib if G4LIB_BUILD_ZLIB is set.
+
 17th November 2009  Laurent Garnier
-- Fix SceneHandler removing viewer if class destructor call 
-  before G4VSceneHandler calls it
+- Allow arbitrary viewer deletion (fixes crash)
+
+17th November 2009  Gabriele Cosmo
+- GNUmakefile: Added SUBLIBS += G4gl2ps for OPENGL and OI.
+
+15th November 2009  John Allison
+- raytracer-V09-02-02: Formal tag to record fixing of bugzilla Problem 1072.
 
 6th November 2009  John Allison
- - vistest-V09-02-01: test19.cc: Use G4UIExecutive.
+- vistest-V09-02-01: test19.cc: Use G4UIExecutive.
 
 3rd November 2009  John Allison  (vis-V09-02-10, greps-V09-02-03, digits_hits-V09-02-02)
Index: trunk/source/visualization/OpenGL/GNUmakefile
===================================================================
--- trunk/source/visualization/OpenGL/GNUmakefile	(revision 1227)
+++ trunk/source/visualization/OpenGL/GNUmakefile	(revision 1228)
@@ -1,3 +1,3 @@
-# $Id: GNUmakefile,v 1.10 2009/03/05 11:17:42 lgarnier Exp $
+# $Id: GNUmakefile,v 1.12 2010/01/06 15:05:29 lgarnier Exp $
 
 name := G4OpenGL
@@ -39,6 +39,4 @@
 CPPFLAGS += -I$(G4BASE)/digits_hits/hits/include
 
-#INTYLIBS += -L$(G4LIBDIR)
-
 include $(G4INSTALL)/config/moc.gmk
 include $(G4INSTALL)/config/common.gmk
Index: trunk/source/visualization/OpenGL/History
===================================================================
--- trunk/source/visualization/OpenGL/History	(revision 1227)
+++ trunk/source/visualization/OpenGL/History	(revision 1228)
@@ -1,3 +1,3 @@
-$Id: History,v 1.160 2009/11/17 11:52:51 gcosmo Exp $
+$Id: History,v 1.162 2010/01/06 15:05:29 lgarnier Exp $
 -------------------------------------------------------------------
 
@@ -17,4 +17,11 @@
      * Reverse chronological order (last date on top), please *
      ----------------------------------------------------------
+
+6th January 2010  Laurent Garnier (needs interfaces-V09-02-07 + laurent-QtUI_with_tabs_v1)
+- GNUMakefile : Add include for interfaces/basic
+- G4OpenGLQtWiewer : Integration into QtUI Tab
+
+17th November 2009  John Allison  (opengl-V09-02-10)
+- Tagged for vis tag.
 
 17th November 2009  Gabriele Cosmo
Index: trunk/source/visualization/OpenGL/include/G4OpenGLImmediateQtViewer.hh
===================================================================
--- trunk/source/visualization/OpenGL/include/G4OpenGLImmediateQtViewer.hh	(revision 1227)
+++ trunk/source/visualization/OpenGL/include/G4OpenGLImmediateQtViewer.hh	(revision 1228)
@@ -56,5 +56,5 @@
   void initializeGL ();
   void DrawView ();
-  void FinishView ();
+  //  void FinishView ();
   void resizeGL(int width,int height);
   void paintGL();
@@ -70,4 +70,5 @@
   void contextMenuEvent(QContextMenuEvent *e);
   void keyPressEvent (QKeyEvent * event); 
+  void paintEvent(QPaintEvent *event);
 private:
   void ComputeView ();
Index: trunk/source/visualization/OpenGL/include/G4OpenGLQtViewer.hh
===================================================================
--- trunk/source/visualization/OpenGL/include/G4OpenGLQtViewer.hh	(revision 1227)
+++ trunk/source/visualization/OpenGL/include/G4OpenGLQtViewer.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4OpenGLQtViewer.hh,v 1.20 2009/10/21 08:14:44 lgarnier Exp $
+// $Id: G4OpenGLQtViewer.hh,v 1.21 2010/01/06 15:05:29 lgarnier Exp $
 // GEANT4 tag $Name:  $
 //
Index: trunk/source/visualization/OpenGL/src/G4OpenGLImmediateQtViewer.cc
===================================================================
--- trunk/source/visualization/OpenGL/src/G4OpenGLImmediateQtViewer.cc	(revision 1227)
+++ trunk/source/visualization/OpenGL/src/G4OpenGLImmediateQtViewer.cc	(revision 1228)
@@ -107,4 +107,5 @@
 
   updateQWidget();
+
 #ifdef G4DEBUG_VIS_OGL
   printf("G4OpenGLImmediateQtViewer::DrawView  ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^\n");
@@ -150,16 +151,4 @@
 #endif
   fHasToRepaint = true;
-}
-
-void G4OpenGLImmediateQtViewer::FinishView()
-{
-#ifdef G4DEBUG_VIS_OGL
-  printf("G4OpenGLImmediateQtViewer::FinishView() BEGIN\n");
-#endif
-  glFlush ();
-#ifdef G4DEBUG_VIS_OGL
-  printf("G4OpenGLImmediateQtViewer::FinishView() END\n");
-#endif
-
 }
 
@@ -172,6 +161,12 @@
 ,int aHeight)
 {  
+#ifdef G4DEBUG_VIS_OGL
+  printf("\n\nG4OpenGLImmediateQtViewer::resizeGL VVVV\n");
+#endif
   ResizeWindow(aWidth,aHeight);
   fHasToRepaint = sizeHasChanged();
+#ifdef G4DEBUG_VIS_OGL
+  printf("\n\nG4OpenGLImmediateQtViewer::resizeGL ^^^^^\n");
+#endif
 }
 
@@ -180,5 +175,5 @@
 {
 #ifdef G4DEBUG_VIS_OGL
-  printf("\n\nG4OpenGLImmediateQtViewer::paintGL ??\n");
+  printf("\n\nG4OpenGLImmediateQtViewer::paintGL ?? %d W:%d H:%d \n",fHasToRepaint,getWinWidth(),getWinHeight());
 #endif
   if (!fReadyToPaint) {
@@ -186,4 +181,8 @@
     return;
   }
+  if ((getWinWidth() == 0) && (getWinHeight() == 0)) {
+      return;
+  }
+
   // DO NOT RESIZE IF SIZE HAS NOT CHANGE
   if ( !fHasToRepaint) {
@@ -209,5 +208,5 @@
     } else if ((sw == 0) && (sh == 0)) { // NOT A TOP LEVEL WIDGET
       if (((getWinWidth() == (unsigned int)width())) &&(getWinHeight() == (unsigned int) height())) { 
-        //        return;
+        return;
       }
     }
@@ -270,7 +269,25 @@
 }
 
+void G4OpenGLImmediateQtViewer::paintEvent(QPaintEvent *event) {
+  //  fHasToRepaint= false;
+#ifdef G4DEBUG_VIS_OGL
+  printf("\n\nG4OpenGLImmediateQtViewer::paintEvent VVVVVVVVV\n");
+#endif
+  updateGL();
+#ifdef G4DEBUG_VIS_OGL
+  printf("\n\nG4OpenGLImmediateQtViewer::paintEvent ^^^^^^^^^\n");
+#endif
+}
+
+
 void G4OpenGLImmediateQtViewer::updateQWidget() {
   fHasToRepaint= true;
+#ifdef G4DEBUG_VIS_OGL
+  printf("\n\nG4OpenGLImmediateQtViewer::updateQWidget VVVVVVVVV\n");
+#endif
   updateGL();
+#ifdef G4DEBUG_VIS_OGL
+  printf("\n\nG4OpenGLImmediateQtViewer::updateQWidget ^^^^^^^^^\n");
+#endif
   fHasToRepaint= false;
 }
@@ -282,4 +299,7 @@
 //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
 {
+#ifdef G4DEBUG_VIS_OGL
+  printf("\n\nG4OpenGLImmediateQtViewer::ShowView VVVV\n");
+#endif
 #if QT_VERSION < 0x040000
   setActiveWindow();
@@ -287,4 +307,7 @@
   activateWindow();
 #endif
-}
-#endif
+#ifdef G4DEBUG_VIS_OGL
+  printf("\n\nG4OpenGLImmediateQtViewer::ShowView ^^^^^\n");
+#endif
+}
+#endif
Index: trunk/source/visualization/OpenGL/src/G4OpenGLQtViewer.cc
===================================================================
--- trunk/source/visualization/OpenGL/src/G4OpenGLQtViewer.cc	(revision 1227)
+++ trunk/source/visualization/OpenGL/src/G4OpenGLQtViewer.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4OpenGLQtViewer.cc,v 1.45 2009/10/21 08:14:44 lgarnier Exp $
+// $Id: G4OpenGLQtViewer.cc,v 1.46 2010/01/06 15:05:29 lgarnier Exp $
 // GEANT4 tag $Name:  $
 //
@@ -104,9 +104,5 @@
 //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
 {
-  // G4Qt* interactorManager = G4Qt::getInstance ();
-
-#ifdef G4DEBUG_VIS_OGL
-  printf("G4OpenGLQtViewer::CreateMainWindow :: BEGIN \n");
-#endif
+
   if(fWindow) return; //Done.
 
@@ -133,7 +129,4 @@
   if (!res) { // we have to do a dialog
 
-#ifdef G4DEBUG_VIS_OGL
-    printf("G4OpenGLQtViewer::CreateMainWindow :: NO UI get Parent ? \n");
-#endif
     QWidget *myParent = getParentWidget();
 #ifdef G4DEBUG_VIS_OGL
@@ -149,7 +142,4 @@
     QHBoxLayout *mainLayout = new QHBoxLayout(fGLWindow);
     
-#ifdef G4DEBUG_VIS_OGL
-    printf("G4OpenGLQtViewer::CreateMainWindow :: After create Layout fGLWindow:%d \n",fGLWindow);
-#endif
     mainLayout->setMargin(0);
     mainLayout->setSpacing(0);   
@@ -160,13 +150,7 @@
 #else
       fGLWindow->setWindowTitle( name);
-#ifdef G4DEBUG_VIS_OGL
-      printf("G4OpenGLQtViewer::CreateMainWindow :: is QMainWindow \n");
-#endif
 #endif
     }
 #if QT_VERSION >= 0x040000
-#ifdef G4DEBUG_VIS_OGL
-    printf("G4OpenGLQtViewer::CreateMainWindow ::  set layout to fGLWindow:%d \n",fGLWindow);
-#endif
     fGLWindow->setLayout(mainLayout);
 #endif
@@ -190,15 +174,10 @@
     fGLWindow = fWindow;
   }
-  
-  
-  
+
   if(!fWindow) return;
   
   if (!fContextMenu) 
     createPopupMenu();
-  
-#ifdef G4DEBUG_VIS_OGL
-  printf("G4OpenGLQtViewer::CreateMainWindow :: END \n");
-#endif
+
 }
 
@@ -257,9 +236,4 @@
 
 #ifdef G4DEBUG_VIS_OGL
-  G4UImanager* UI = G4UImanager::GetUIpointer();
-  printf("G4OpenGLQtViewer::getParentWidget :: UImanager %d++++++++++++\n",UI);
-#endif
-
-#ifdef G4DEBUG_VIS_OGL
   printf("G4OpenGLQtViewer::G4OpenGLQtViewer END\n");
 #endif
@@ -2669,13 +2643,4 @@
 #endif
   
-  //   if (interactorManager) {
-  //     if (interactorManager->GetUIVisWidget()) {
-  //       fGLWindow = interactorManager->GetUIVisWidget();
-  //       return interactorManager->GetUIVisWidget(); 
-  //     }
-  //   }
-  //
-
-
   bool found = false;
   
Index: trunk/source/visualization/OpenInventor/GNUmakefile
===================================================================
--- trunk/source/visualization/OpenInventor/GNUmakefile	(revision 1227)
+++ trunk/source/visualization/OpenInventor/GNUmakefile	(revision 1228)
@@ -1,3 +1,3 @@
-# $Id: GNUmakefile,v 1.9 2009/02/16 15:31:05 lgarnier Exp $
+# $Id: GNUmakefile,v 1.10 2009/11/17 11:33:18 gcosmo Exp $
 
 name := G4OpenInventor
@@ -7,9 +7,6 @@
 endif
 
-# For debug mode
-CPPFLAGS += -DG4DEBUG_VIS_OI
-
-GLOBLIBS  = libG4vis_management.lib libG4modeling.lib
-GLOBLIBS += libG4interfaces.lib libG4run.lib libG4event.lib
+GLOBLIBS  = libG4vis_management.lib libG4modeling.lib libG4gl2ps.lib
+GLOBLIBS += libG4zlib.lib libG4interfaces.lib libG4run.lib libG4event.lib
 GLOBLIBS += libG4tracking.lib libG4processes.lib libG4digits_hits.lib
 GLOBLIBS += libG4track.lib libG4particles.lib libG4geometry.lib
@@ -37,6 +34,4 @@
 CPPFLAGS += -I$(G4BASE)/digits_hits/hits/include
 
-INTYLIBS += -L$(G4LIBDIR) -lG4gl2ps
-
 include $(G4INSTALL)/config/common.gmk
 
Index: trunk/source/visualization/OpenInventor/History
===================================================================
--- trunk/source/visualization/OpenInventor/History	(revision 1227)
+++ trunk/source/visualization/OpenInventor/History	(revision 1228)
@@ -1,3 +1,3 @@
-$Id: History,v 1.102 2009/09/29 21:23:36 allison Exp $
+$Id: History,v 1.104 2009/11/17 17:47:49 allison Exp $
 -------------------------------------------------------------------
 
@@ -20,4 +20,10 @@
 History file for visualization/OpenInventor
 -------------------------------------------
+
+17th November 2009  John Allison  (openinventor-V09-02-03)
+- Tagged for vis tag.
+
+17th November 2009  Gabriele Cosmo
+- Fixed GNUmakefile.  Fixes build problem with gl2ps on Windows.
 
 29 September 2009  John Allison  (openinventor-V09-02-02)
Index: trunk/source/visualization/RayTracer/History
===================================================================
--- trunk/source/visualization/RayTracer/History	(revision 1227)
+++ trunk/source/visualization/RayTracer/History	(revision 1228)
@@ -1,3 +1,3 @@
-$Id: History,v 1.59 2009/10/21 15:24:53 allison Exp $
+$Id: History,v 1.60 2009/11/15 12:33:54 allison Exp $
 -------------------------------------------------------------------
 
@@ -25,4 +25,9 @@
 ---------------------------------------
 
+15th November 2009  John Allison  (raytracer-V09-02-02)
+- Formal tag to record fixing of bugzilla Problem 1072.
+  o There is no change of source code.
+  o This was actullay fixed in raytracer-V09-02-00, which is already accepted.
+
 21st October 2009  John Allison  (raytracer-V09-02-01 coworks greps-V09-02-02)
 - Added AddCompound (const G4THitsMap<G4double>&) methods.
@@ -34,5 +39,5 @@
 19 August 2009 Laurent Garnier
 - G4RayTracerViewer.cc, G4RayTracerXViewer.cc : Fix an bad use of fVP
-  parameters
+  parameters [bugzilla Problem 1072]
 
 18 August 2009 Laurent Garnier
Index: trunk/source/visualization/externals/gl2ps/GNUmakefile
===================================================================
--- trunk/source/visualization/externals/gl2ps/GNUmakefile	(revision 1227)
+++ trunk/source/visualization/externals/gl2ps/GNUmakefile	(revision 1228)
@@ -1,3 +1,3 @@
-# $Id: GNUmakefile,v 1.2 2009/11/02 14:54:31 lgarnier Exp $
+# $Id: GNUmakefile,v 1.5 2009/11/18 17:15:11 gcosmo Exp $
 # -------------------------------------------------------------
 # GNUmakefile for gl2ps.  Laurent Garnier, 6/2/09.
@@ -12,7 +12,5 @@
 endif
 
-ifdef G4LIB_BUILD_ZLIB
-  CPPFLAGS += -I$(G4BASE)/visualization/externals/zlib/include
-endif
+GLOBLIBS = libG4zlib.lib
 
 include $(G4INSTALL)/config/architecture.gmk
@@ -20,3 +18,7 @@
 include $(G4INSTALL)/config/interactivity.gmk
 
+ifdef G4LIB_BUILD_ZLIB
+  CPPFLAGS += -I$(G4BASE)/visualization/externals/zlib/include
+endif
+
 include $(G4INSTALL)/config/common.gmk
Index: trunk/source/visualization/externals/gl2ps/History
===================================================================
--- trunk/source/visualization/externals/gl2ps/History	(revision 1227)
+++ trunk/source/visualization/externals/gl2ps/History	(revision 1228)
@@ -1,3 +1,3 @@
-$Id: History,v 1.10 2009/11/02 14:54:31 lgarnier Exp $
+$Id: History,v 1.15 2009/11/18 17:23:36 gcosmo Exp $
 -------------------------------------------------------------------
 
@@ -17,4 +17,13 @@
      * Reverse chronological order (last date on top), please *
      ----------------------------------------------------------
+
+18 Nov 2009, Gabriele Cosmo (visexternal-V09-02-06)
+ - Added GLOBLIBS dependencies to GNUmakefile to allow for building
+   DLLs on Windows. Removed redundant CPPFLAGS addition.
+ - Re-instated fix to gl2ps.cc.
+
+17 Nov 2009, John Allison, Gabriele Cosmo (visexternal-V09-02-05)
+ - Added dependency on zlib if G4LIB_BUILD_ZLIB is set and corrected
+   inclusion of zlib.h in gl2ps.cc
 
 2 Nov 2009, Laurent Garnier 
Index: trunk/source/visualization/externals/gl2ps/src/G4OpenGL2PSAction.cc
===================================================================
--- trunk/source/visualization/externals/gl2ps/src/G4OpenGL2PSAction.cc	(revision 1227)
+++ trunk/source/visualization/externals/gl2ps/src/G4OpenGL2PSAction.cc	(revision 1228)
@@ -125,5 +125,5 @@
      GL2PS_BEST_ROOT | GL2PS_SILENT | GL2PS_DRAW_BACKGROUND;
   int sort = GL2PS_BSP_SORT;
-  sort = GL2PS_SIMPLE_SORT;
+  //int sort = GL2PS_SIMPLE_SORT;
   GLint buffsize = 0;
   buffsize += 1024*1024;
Index: trunk/source/visualization/externals/gl2ps/src/gl2ps.cc
===================================================================
--- trunk/source/visualization/externals/gl2ps/src/gl2ps.cc	(revision 1227)
+++ trunk/source/visualization/externals/gl2ps/src/gl2ps.cc	(revision 1228)
@@ -92,5 +92,5 @@
 #include "Geant4_gl2ps.h"
 
-#include <math.h>
+#include <cmath>
 #include <string.h>
 #include <sys/types.h>
@@ -99,8 +99,6 @@
 #include <float.h>
 
-#if defined(G4LIB_USE_ZLIB)
 #define GL2PS_HAVE_ZLIB
 #include <zlib.h>
-#endif
 
 #if defined(GL2PS_HAVE_LIBPNG)
@@ -121,5 +119,5 @@
 #define GL2PS_ZOFFSET       5.0e-2F
 #define GL2PS_ZOFFSET_LARGE 20.0F
-#define GL2PS_ZERO(arg)     (fabs(arg) < 1.e-20)
+#define GL2PS_ZERO(arg)     (std::fabs(arg) < 1.e-20)
 
 /* Primitive types */
@@ -749,7 +747,7 @@
   
   for(i = 1; i < n; i++){
-    if(fabs(rgba[0][0] - rgba[i][0]) > threshold[0] ||
-       fabs(rgba[0][1] - rgba[i][1]) > threshold[1] ||
-       fabs(rgba[0][2] - rgba[i][2]) > threshold[2])
+    if(std::fabs(rgba[0][0] - rgba[i][0]) > threshold[0] ||
+       std::fabs(rgba[0][1] - rgba[i][1]) > threshold[1] ||
+       std::fabs(rgba[0][2] - rgba[i][2]) > threshold[2])
       return GL_FALSE;
   }
Index: trunk/source/visualization/gMocren/History
===================================================================
--- trunk/source/visualization/gMocren/History	(revision 1227)
+++ trunk/source/visualization/gMocren/History	(revision 1228)
@@ -1,3 +1,3 @@
-$Id: History,v 1.7 2009/11/05 11:37:12 gcosmo Exp $
+$Id: History,v 1.9 2009/12/03 11:44:42 akimura Exp $
 -------------------------------------------------------------------
 
@@ -20,4 +20,12 @@
 History file for visualization/gMocren sub-category
 ---------------------------------------------------
+
+3 December 2009  Akinori Kimura
+Line 363 of G4GMocrenFileSceneHandler.cc was deleted.
+It was a debug code with G4cout.
+Another file I/O bug was fixed. The following files were committed.
+G4GMocrenFileViewer.cc
+G4GMocrenFileSceneHandler.cc
+G4GMocrenIO.{cc,hh}
 
 5 November 2009  Gabriele Cosmo (gMocren-V09-02-03)
Index: trunk/source/visualization/gMocren/include/G4GMocrenIO.hh
===================================================================
--- trunk/source/visualization/gMocren/include/G4GMocrenIO.hh	(revision 1227)
+++ trunk/source/visualization/gMocren/include/G4GMocrenIO.hh	(revision 1228)
@@ -43,4 +43,5 @@
 
   void clear();
+  void clearImage();
   void setSize(int _size[3]);
   void getSize(int _size[3]);
@@ -292,4 +293,5 @@
   void setModalityImage(short * _image);
   short * getModalityImage(int _z);
+  void clearModalityImage();
   // set/get the modality image density map
   void setModalityImageDensityMap(std::vector<float> & _map);
Index: trunk/source/visualization/gMocren/src/G4GMocrenFileCTtoDensityMap.cc
===================================================================
--- trunk/source/visualization/gMocren/src/G4GMocrenFileCTtoDensityMap.cc	(revision 1227)
+++ trunk/source/visualization/gMocren/src/G4GMocrenFileCTtoDensityMap.cc	(revision 1228)
@@ -1,2 +1,27 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
 #include "G4GMocrenFileCTtoDensityMap.hh"
 
Index: trunk/source/visualization/gMocren/src/G4GMocrenFileSceneHandler.cc
===================================================================
--- trunk/source/visualization/gMocren/src/G4GMocrenFileSceneHandler.cc	(revision 1227)
+++ trunk/source/visualization/gMocren/src/G4GMocrenFileSceneHandler.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4GMocrenFileSceneHandler.cc,v 1.10 2009/11/05 11:34:01 gcosmo Exp $
+// $Id: G4GMocrenFileSceneHandler.cc,v 1.12 2009/12/03 11:44:42 akimura Exp $
 // GEANT4 tag $Name:  $
 //
@@ -301,4 +301,5 @@
     
     // initializations
+    //kgMocrenIO->clearModalityImage();
     kgMocrenIO->clearDoseDistAll();
     kgMocrenIO->clearROIAll();
@@ -361,5 +362,4 @@
 	    modality[ixy] = kgMocrenIO->convertDensityToHU(itr->second);
 	  } else {
-	    G4cout << "ABC : " << x << ", " <<  y << ", " << z << G4endl;
 	    modality[ixy] = -1024;
 	  }
Index: trunk/source/visualization/gMocren/src/G4GMocrenFileViewer.cc
===================================================================
--- trunk/source/visualization/gMocren/src/G4GMocrenFileViewer.cc	(revision 1227)
+++ trunk/source/visualization/gMocren/src/G4GMocrenFileViewer.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4GMocrenFileViewer.cc,v 1.2 2009/10/12 10:04:35 akimura Exp $
+// $Id: G4GMocrenFileViewer.cc,v 1.3 2009/12/03 11:44:42 akimura Exp $
 // GEANT4 tag $Name:  $
 //
@@ -107,11 +107,11 @@
     G4cerr << "***** G4GMocrenFileViewer::ClearView (): No effects " << G4endl;
 
-  if(kSceneHandler.kGddDest) {
-    kSceneHandler.kGddDest.close();
+  //if(kSceneHandler.kGddDest) {
+    //kSceneHandler.kGddDest.close();
     // Re-open with same filename...
-    kSceneHandler.kGddDest.open(kSceneHandler.kGddFileName);
+    //kSceneHandler.kGddDest.open(kSceneHandler.kGddFileName);
     kSceneHandler.kFlagInModeling = false;
     kSceneHandler.GFBeginModeling();
-  }
+    //}
 }
 
Index: trunk/source/visualization/gMocren/src/G4GMocrenIO.cc
===================================================================
--- trunk/source/visualization/gMocren/src/G4GMocrenIO.cc	(revision 1227)
+++ trunk/source/visualization/gMocren/src/G4GMocrenIO.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4GMocrenIO.cc,v 1.4 2009/11/05 03:14:12 akimura Exp $
+// $Id: G4GMocrenIO.cc,v 1.5 2009/12/03 11:44:42 akimura Exp $
 // GEANT4 tag $Name:  $
 //
@@ -170,12 +170,12 @@
   kMinmax[1] = (T)-32109;
 
-  /*
-    if(!image.empty()) {
-    typename std::vector<T *>::iterator itr;
-    for(itr = image.begin(); itr != image.end(); itr++) {
+  clearImage();
+}
+template <typename T> 
+void GMocrenDataPrimitive<T>::clearImage() {
+  typename std::vector<T *>::iterator itr;
+  for(itr = kImage.begin(); itr != kImage.end(); itr++) {
     delete [] *itr;
-    }
-    }
-  */
+  }
   kImage.clear();
 }
@@ -3368,4 +3368,8 @@
   return kModality.getImage(_z);
 }
+void G4GMocrenIO::clearModalityImage() {
+  
+  kModality.clearImage();
+}
 // set/get the modality image density map
 void G4GMocrenIO::setModalityImageDensityMap(std::vector<float> & _map) {
Index: trunk/source/visualization/management/History
===================================================================
--- trunk/source/visualization/management/History	(revision 1227)
+++ trunk/source/visualization/management/History	(revision 1228)
@@ -1,3 +1,3 @@
-$Id: History,v 1.134 2009/11/17 14:37:06 lgarnier Exp $
+$Id: History,v 1.137 2009/11/22 14:08:09 allison Exp $
 
 -------------------------------------------------------------------
@@ -27,7 +27,16 @@
 ------------------------------------------------------
 
+22nd November 2009  John Allison  (visman-V09-02-08)
+- G4VisCommandsSceneAdd.cc: /vis/scene/add/trajectories rich:
+  o Added G4RichTrajectoryPoint().GetAttDefs() to informational.
+
+17th November 2009  John Allison  (visman-V09-02-07)
+- Tagged.
+
 17th November 2009  Laurent Garnier
-- G4VViewer::Fix SceneHandler removing viewer if class destructor call 
-  before G4VSceneHandler calls it
+- Allow arbitrary viewer deletion (fixes crash).
+  o G4VViewer::~G4VViewer: Removes itself from viewer list.
+  o G4VSceneHandler::~G4VSceneHandler: better algorithm for removing viewers
+  to handle viewer self removal.
 
 16th November 2009  Laurent Garnier
